<template>
  <div class="box">
    <a-spin :spinning="loading">
      <li class="title"><h1>赛事日历</h1></li>
      <li class="badges">
        <div class="preferChoice">
          筛选设置：
          <a-badge color="#ff3434" text="已预约"/>
          <a-switch default-checked @change="onChangeReserve"></a-switch>
          <a-badge color="#2aa8ec" text="已订阅"/>
          <a-switch default-checked @change="onChangeSubscribe"></a-switch>
          <a-badge color="#993399" text="推荐赛事"/>
          <a-switch default-checked @change="onChangeRecommend"></a-switch>
          <a-badge color="white" text="其他可用赛事"/>
          <a-switch default-checked @change="onChangeNormal"></a-switch>
        </div>
      </li>
      <li style="display: flex">
        <div class="lengthChoice">
          比赛时长：
          <a-select default-value="all" style="width: 120px" @change="handleChangeLength">
            <a-select-option value="all">所有</a-select-option>
            <a-select-option value="1">小于1小时</a-select-option>
            <a-select-option value="2">小于3小时</a-select-option>
            <a-select-option value="3">小于8小时</a-select-option>
            <a-select-option value="4">小于24小时</a-select-option>
            <a-select-option value="5">大于24小时</a-select-option>
          </a-select>
        </div>
        <div class="lengthChoice">
          比赛难度：
          <a-select default-value="all" style="width: 120px" @change="handleChangeDiff">
            <a-select-option value="all">所有</a-select-option>
            <a-select-option :value="1">简单</a-select-option>
            <a-select-option :value="2">中等</a-select-option>
            <a-select-option :value="3">困难</a-select-option>
          </a-select>
        </div>
        <div>
          比赛时间段：
          <a-range-picker v-model="rangePicker"
                          :show-time="{
                           defaultValue: [moment('00:00:00', 'HH:mm:ss'), moment('11:59:59', 'HH:mm:ss')]
                          }"
                          format="YYYY-MM-DD HH:mm:ss" @ok="onTimeOk" @change="onTimeChange" @openChange="openChange"/>
        </div>
      </li>
      <a-calendar style="margin-bottom: 60px" v-model="calendarDate">
        <ul slot="dateCellRender" slot-scope="value" class="events">
          <div v-for="item in getListData(value)" :key="item.game_id">
            <li v-if="item.checked==1">
              <a-popover :title=item.game_name trigger="click" placement="bottomLeft"
                         :overlayStyle="{maxWidth: '500px'}">
                <div slot="content" class="popover-content">
                  <p v-if="item.platform"><span>平&emsp;&emsp;台：</span>{{ item.platform }}</p>
                  <p><span>开始时间：</span>{{ item.game_start_time }}</p>
                  <p v-if="item.game_end_time"><span>结束时间：</span>{{ item.game_end_time }}</p>
                  <p v-if="item.duration"><span>时&emsp;&emsp;长：</span>{{ item.duration + ':00' }}</p>
                  <p><span>难&emsp;&emsp;度：</span>{{ item.level == 1 ? '简单' : item.level == 2 ? '中等' : '困难' }}</p>
                  <p>
                    <span>链&emsp;&emsp;接：</span>
                    <a style="flex: 1" :href=item.website target="_blank">{{ item.website }}</a>
                  </p>
                  <p :style="item | degreeVisible(that)" style="align-items: center">
                    <span>推荐指数：</span>
                    <a-rate :default-value="item | degree" disabled/>
                  </p>
                  <a-button v-if="!item.reserved"
                            type="primary"
                            :loading="reserveLoading"
                            @click="ReserveGame(item.game_id)">预约</a-button>
                  <a-button v-else type="primary"
                            :loading="reserveLoading"
                            @click="ReserveGameCancel(item.game_id)">取消预约</a-button>
                </div>
                <p class="game-block" :style="item | style(that)">{{ item.game_name }}</p>
              </a-popover>
            </li>
          </div>
        </ul>
      </a-calendar>
      <div>
        <li class="title"><h1>我的自定义赛事</h1></li>
        <a-button type="primary" @click="showModal">
          上传自定义赛事
        </a-button>
        <br/><br/>
        <a-modal v-model="modal_visible" title="填写自定义赛事信息"
                 @ok="handleSubmit()"
                 :confirmLoading="confirmLoading"
                 :destroyOnClose="true">
          <a-form :form="new_cust_form" :label-col="{ span: 5 }" :wrapper-col="{ span: 12 }">
            <a-form-item label="比赛名称">
              <a-input placeholder="请输入比赛名称（不能超过32个字符）"
                       :maxLength="32"
                       v-decorator="['game_name', {
                         rules: [
                             { required: true, message: '请输入比赛名称！'},
                             {max: 32, message: '比赛名称不能超过32个字符'}
                         ]}]"
              />
            </a-form-item>
            <a-form-item label="起止时间">
              <a-range-picker
                  :disabled-date="disabledDate"
                  :disabled-time="disabledRangeTime"
                  :show-time="{
          hideDisabledOptions: true,
          defaultValue: [moment('00:00:00', 'HH:mm:ss'), moment('11:59:59', 'HH:mm:ss')]
        }"
                  format="YYYY-MM-DD HH:mm:ss"
                  v-decorator="['cust_game_time', { rules: [{ required: true, message: '请选择起止时间！'}] }]"
              />
            </a-form-item>
            <a-form-item label="比赛链接">
              <a-input placeholder="请输入比赛链接（不能超过100个字符）"
                       :maxLength="100"
                       v-decorator="['website', {
                         rules: [
                             { required: true, message: '请输入比赛链接！'},
                             { max: 100, message: '比赛链接不能超过100个字符！'}
                         ]}]"
              />
            </a-form-item>
            <a-form-item label="举办方">
              <a-select v-decorator="['platform', { rules: [{ required: true, message: '请选择举办方！'}] }]"
                        placeholder="请选择">
                <a-select-option value="codeforces">codeforces</a-select-option>
                <a-select-option value="atcoder">atcoder</a-select-option>
                <a-select-option value="力扣">力扣</a-select-option>
                <a-select-option value="牛客网">牛客网</a-select-option>
                <a-select-option value="洛谷">洛谷</a-select-option>
                <a-select-option value="自定义">自定义</a-select-option>
              </a-select>
            </a-form-item>
            <a-form-item label="难度">
              <a-radio-group v-decorator="['level', { rules: [{ required: true, message: '请选择难度！'}] }]">
                <a-radio :value="1">简单</a-radio>
                <a-radio :value="2">中等</a-radio>
                <a-radio :value="3">困难</a-radio>
              </a-radio-group>
            </a-form-item>
            <a-form-item label="是否公开">
              <a-switch default-checked
                        v-decorator="['cust_public', {initialValue: true, rules: [{ required: true}] }]"></a-switch>
            </a-form-item>
          </a-form>
        </a-modal>
        <a-table rowKey="game_id" :columns="tableColumns" :data-source="this.cust_matches">
          <span slot="website" slot-scope="text, record"><a :href="record.website" target="_blank">{{
              record.website
            }}</a></span>
          <span slot="public" slot-scope="text, record">{{ record.cust_public ? '公开' : '私密' }}</span>
          <template slot="operation" slot-scope="text, record, index">
            <a class="operation" @click="handleDelete(record, index)">删除</a>
          </template>
        </a-table>
      </div>
    </a-spin>
  </div>
</template>
<script>
import moment from 'moment';
import {mapState} from 'vuex'
//自定义比赛信息表
const tableColumns = [
  {
    title: '比赛名',
    dataIndex: 'game_name',
    key: 'game_name',
    width: '20%',

  },
  {
    title: '开始时间',
    dataIndex: 'game_start_time',
    key: 'game_start_time',
    width: '15%',
  },
  {
    title: '结束时间',
    dataIndex: 'game_end_time',
    key: 'game_end_time',
    width: '15%',
  },
  {
    title: '比赛链接',
    dataIndex: 'website',
    key: 'website',
    width: '250px',
    scopedSlots: {customRender: 'website'},
  },
  {
    title: '举办方',
    dataIndex: 'platform',
    key: 'platform',
    width: '10%',
  },
  {
    title: '公开状态',
    dataIndex: 'cust_public',
    key: 'cust_public',
    width: '10%',
    scopedSlots: {customRender: 'public'},
  },
  {
    title: '操作',
    key: 'operation',
    width: '50px',
    scopedSlots: {customRender: 'operation'},
  },
]
export default {
  data() {
    return {
      that: this,
      token: '',
      needType: ['Reserve', 'Subscribe', 'Normal', 'Recommend'],
      matches: [],
      cust_matches: [],
      subscribes: [],
      reserves: [],
      visible: false,
      modal_visible: false,
      condition_duration: 'all',
      condition_level: "all",
      tableColumns,
      new_cust_form: this.$form.createForm(this, {name: 'new_game'}),
      calendarDate: this.$moment(),
      searchForm: {
        start_time: "",
        end_time: "",
        reserved: true,
        subscribed: true,
        recommended: true,
        other: true,
        duration: 'all',
        level: 'all'
      },
      game_list: [],
      loading: false,
      confirmLoading: false,
      isOK: false,
      rangePicker: null,
      reserveLoading: false
    }
  },

  computed: {
    ...mapState('user', ['user_info'])
  },

  filters: {

    degreeVisible(item, that) {
      if (that.searchForm.reserved && item.reserved) return 'display: none';
      if (that.searchForm.subscribed && item.subscribed) return 'display: none';
      if (that.searchForm.recommended && item.recommended) return '';
      if (that.searchForm.other && item.other) return 'display: none';
      return 'display: none';
    },

    degree(item) {
      switch (item.recommend_degree) {
        case 33: return 1;
        case 67: return 3;
        case 100: return 5;
        default: return 0
      }
    },

    style(item, that) {
      if (that.searchForm.reserved && item.reserved) return 'background: #ff3434;';
      if (that.searchForm.subscribed && item.subscribed) return 'background: #2aa8ec;';
      if (that.searchForm.recommended && item.recommended) return `background: rgba(153,51,153, ${item.recommend_degree}%)`;
      if (that.searchForm.other && item.other) return 'background: #517E55;';
      return ''
    }
  },
  //挂载阶段获取预约、订阅、比赛信息
  mounted: function () {
    this.getGamesList()
    this.getUserCustomGamesList()
  },
  methods: {
    moment,

    async getGamesList(params = {}) {
      this.loading = !params.noLoading
      await this.$axios.get('game/query', {
        start_time: this.searchForm.start_time,
        end_time: this.searchForm.end_time
      }).then((res) => {
        if (res.code == undefined) {
          this.game_list = res
          this.filterGamesList()
        }
      }).catch(() => {
      });
      this.loading = false
    },
    getUserCustomGamesList() {
      this.$axios.get('game/custom/query/user').then((res) => {
        if (res.code == undefined) {
          this.cust_matches = res
        }
      }).catch(() => {
      });
    },

    filterGamesList() {
      this.matches = this.game_list.filter(item => {
        let reserveFlag = false
        let subscribeFlag = false
        let recommendFlag = false
        let otherFlag = false
        if (this.searchForm.reserved) reserveFlag = item.reserved;
        if (this.searchForm.subscribed) subscribeFlag = item.subscribed;
        if (this.searchForm.recommended) recommendFlag = item.recommended;
        if (this.searchForm.other) otherFlag = item.other;
        let flag = reserveFlag || subscribeFlag || recommendFlag || otherFlag;
        if (flag) {
          let diffTime = 0
          let flag1 = true
          let flag2 = true
          if (item.game_end_time) {
            diffTime = this.$moment(item.game_end_time).diff(this.$moment(item.game_start_time))
          } else if (item.duration) {
            diffTime = this.$moment.duration(`${item.duration}:00`).as('seconds') * 1000
          }
          if (this.searchForm.duration == '1') {
            flag1 = diffTime < 60 * 60 * 1000
          } else if (this.searchForm.duration == '2') {
            flag1 = diffTime < 3 * 60 * 60 * 1000
          } else if (this.searchForm.duration == '3') {
            flag1 = diffTime < 8 * 60 * 60 * 1000
          } else if (this.searchForm.duration == '4') {
            flag1 = diffTime < 24 * 60 * 60 * 1000
          } else if (this.searchForm.duration == '5') {
            flag1 = diffTime >= 24 * 60 * 60 * 1000
          }
          if (this.searchForm.level == 'all') {
            flag2 = true
          } else {
            flag2 = this.searchForm.level == item.level
          }
          return flag1 && flag2
        } else {
          return false
        }
      })
    },

    onChangeReserve(val) {
      this.searchForm.reserved = val
      this.filterGamesList(this.matches)
    },
    onChangeSubscribe(val) {
      this.searchForm.subscribed = val
      this.filterGamesList(this.matches)
    },
    onChangeNormal(val) {
      this.searchForm.other = val
      this.filterGamesList(this.matches)
    },
    onChangeRecommend(val) {
      this.searchForm.recommended = val
      this.filterGamesList(this.matches)
    },
    async ReserveGame(game_id) {
      this.reserveLoading = true
      await this.$axios.post("reserve/add", {
        game_id: game_id,
      }).then((res) => {
        if (res.code == 0) {
          this.getGamesList({noLoading: true})
          this.$message.success('操作成功')
        } else {
          this.$message.error('操作失败')
        }
      }).catch(() => {
        this.$message.error('操作失败')
      })
      this.reserveLoading = false
    },
    async ReserveGameCancel(game_id) {
      this.reserveLoading = true
      await this.$axios.post("reserve/delete", {
        game_id: game_id,
      }).then((res) => {
        if (res.code == 0) {
          this.getGamesList({noLoading: true})
          this.$message.success('操作成功')
        } else {
          this.$message.error('操作失败')
        }
      }).catch(() => {
        this.$message.error('操作失败')
      })
      this.reserveLoading = false
    },
    handleChangeDiff(val) {
      this.searchForm.level = val
      this.filterGamesList(this.matches)
    },
    handleChangeLength(val) {
      this.searchForm.duration = val
      this.filterGamesList(this.matches)
    },
    //日历格渲染函数
    getListData(value) {
      let listData = [];
      for (var record of this.matches) {
        let startMonth = new Date(record.game_start_time).getMonth() + 1;
        let startDay = new Date(record.game_start_time).getDate();
        if (value.month() + 1 == startMonth && value.date() == startDay) {
          listData.push(record)
        }
      }
      return listData;
    },

    showModal() {
      this.modal_visible = true;
    },
    range(start, end) {
      const result = [];
      for (let i = start; i < end; i++) {
        result.push(i);
      }
      return result;
    },
    disabledDate(current) {
      return current && current < moment().endOf('day');
    },
    disabledRangeTime() {
      return;
    },
    handleDelete(record, index) {
      this.$axios.post('game/delete', {
        game_id: record.game_id
      }).then(res => {
        if (res.code == 0) {
          this.$notification.success({message: '已删除'})
          if (record.checked == 1) {
            this.getGamesList()
          }
          this.cust_matches.splice(index, 1)
        } else {
          this.$notification.error({message: '删除失败'})
        }
      }).catch(() => {
        this.$notification.error({message: '删除失败'})
      })
    },
    handleSubmit() {
      this.new_cust_form.validateFields(async (err, values) => {
        if (!err) {
          this.confirmLoading = true
          let params = {}
          params.game_name = values.game_name
          params.game_start_time = this.$moment(values.cust_game_time[0]).format('yyyy-MM-DD HH:mm:ss')
          params.game_end_time = this.$moment(values.cust_game_time[1]).format('yyyy-MM-DD HH:mm:ss')
          params.website = values.website
          params.platform = values.platform
          params.level = values.level
          params.cust_public = values.cust_public ? 1 : 0
          await this.$axios.post("game/add", params).then((res) => {
            if (res.code == 0) {
              this.$message.success('添加成功')
              this.modal_visible = false;
              this.new_cust_form.clearField();
              this.getUserCustomGamesList()
            } else {
              this.$message.success('添加失败')
            }
          }).catch(() => {
            this.$message.success('添加失败')
          });
          this.confirmLoading = false
        }
      });
    },

    onTimeChange(value) {
      if (value.length === 0) {
        this.searchForm.start_time = ''
        this.searchForm.end_time = ''
        this.getGamesList()
        this.calendarDate = this.$moment()
      }
    },

    openChange(status) {
      if (!status && !this.isOK) {
        if (this.searchForm.start_time) {
          this.rangePicker = [
              this.$moment(this.searchForm.start_time, 'yyyy-MM-DD HH:mm:ss'),
              this.$moment(this.searchForm.end_time, 'yyyy-MM-DD HH:mm:ss')
          ]
        } else {
          this.rangePicker = null
        }
      }
      this.isOK = false
    },

    /*比赛时间段选择事件*/
    onTimeOk(value) {
      this.isOK = true
      this.searchForm.start_time = this.$moment(this.rangePicker[0]).format('yyyy-MM-DD HH:mm:ss')
      this.searchForm.end_time = this.$moment(this.rangePicker[1]).format('yyyy-MM-DD HH:mm:ss')
      this.getGamesList()
      this.calendarDate = value[0]
    }
  },
};
</script>
<style lang="less" scoped>
.box {
  margin: auto;
  width: 1200px;

  .title {
    border-left: 5px solid #517E55;
    padding-left: 20px;
    height: 30px;
    margin: 20px 0;
    font-weight: bold;
    vertical-align: baseline;

    h1 {
      line-height: 28px;
    }
  }
}

.events {
  list-style: none;
  margin: 0;
  padding: 0;
}

.popover-content {
  p {
    display: flex;
    span {
      width: 75px;
    }
    a {
      word-break: break-all;
    }
  }
}

.events .ant-badge-status {
  overflow: hidden;
  white-space: nowrap;
  width: 100%;
  text-overflow: ellipsis;
  font-size: 12px;
}

.notes-month {
  text-align: center;
  font-size: 28px;
}

.notes-month section {
  font-size: 28px;
}

li {
  margin: 5px;
}

.Reserve {
  background-color: #ff3434;
  border-color: #ff3434;
}

.Subscribe {
  background-color: #2aa8ec;
  border-color: #2aa8ec;
}

.Recommend {
  background-color: #993399;
  border-color: #993399;
}

.Normal {
  background-color: white;
  color: black;
}

.ant-badge {
  margin: 5px;
}

.switches {
  padding: 5px;
}

.badges {
  margin-bottom: 20px;

  .preferChoice {
    display: flex;
    align-items: center;

    /deep/ .ant-switch {
      margin-right: 20px;

      &.ant-switch-checked {
        &:nth-child(2) {
          background-color: #ff3434;
        }

        &:nth-child(4) {
          background-color: #2aa8ec;
        }

        &:nth-child(6) {
          background-color: #993399;
        }
      }
    }
  }
}

.lengthChoice {
  margin-right: 20px;
}

li::marker {
  content: '';
}

/deep/ .ant-fullcalendar-fullscreen {
  .ant-fullcalendar-header {
    padding: 20px;
    text-align: center;
  }

  .ant-radio-group {
    display: none;
  }

  .ant-fullcalendar-date {
    position: relative;
    padding: 0;

    .ant-fullcalendar-value {
      position: absolute;
      right: 0;
    }

    .ant-fullcalendar-content {
      height: 100%;
    }
  }

  .game-block {
    width: 130px;
    box-sizing: border-box;
    padding: 3px 5px;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
    color: #ffffff;
    font-size: 12px;
    border-radius: 3px;
  }
}
</style>